<template>
  <div>
    <v-row justify="center">
      <v-dialog v-model="dialog" persistent max-width="800px">
        <v-card>
          <v-toolbar style="position:relative" color="white" elevation="0">
            <v-spacer />
            <v-toolbar-title class="mt-5">
              <span class="primary--text">
                <v-icon large color="primary" class="mr-2 pb-1">mdi-account-group</v-icon
                ><b>{{ titleDialog }}</b>
              </span>
            </v-toolbar-title>
            <v-spacer />
            <v-tooltip color="red" bottom>
              <template v-slot:activator="{ on }">
                <v-icon v-on="on" style="position:absolute; right: 15px" color="red" @click="close"
                  >mdi-close</v-icon
                >
              </template>
              <span><b>Fechar</b> janela</span>
            </v-tooltip>
          </v-toolbar>
          <v-card-text class="scrollForm">
            <v-container>
              <v-row>
                <v-row class="ml-0">
                  <v-col class="mr-4">
                    <v-text-field
                      v-model="collaborativeWork.name"
                      label="Titulo do Trabalho Colaborativo"
                      required
                      prepend-icon="mdi-pencil-box-outline"
                    ></v-text-field>
                  </v-col>

                  <!-- <v-text-field
                      v-model="collaborativeWork.maxPerTeam"
                      label="Max. de Pessoas por Equipe"
                      required
                      prepend-icon="mdi-account-multiple"
                    ></v-text-field>-->
                </v-row>
                <v-col cols="12" sm="12" md="12">
                  <v-textarea
                    v-model="collaborativeWork.description"
                    outlined
                    label="Descrição"
                    prepend-icon="mdi-card-text-outline"
                  ></v-textarea>
                </v-col>
                <!-- <v-col cols="12" sm="12" md="12">
                  <v-row justify="center">
                    <v-col cols="6">
                      <v-file-input
                        v-model="collaborativeWork.file"
                        dense
                        label="Selecionar Anexo"
                        accept="image/png, image/jpeg, image/bmp, application/pdf, application/xls, application/xml, application/pptx, application/ppt"
                        outlined
                        loader-height="4"
                      />
                    </v-col>
                  </v-row>
                </v-col> -->
              </v-row>
              <v-row>
                <v-spacer />
                <a @click="addAdvanced" aria-describedat>
                  <v-icon>mdi-cog</v-icon>Opções avançadas
                </a>
              </v-row>
              <v-row v-if="disableAdvanced" class="ml-2" justify="center">
                <v-card width="1000" class="mt-2" elevation="0">
                  <v-card-title id="cardTitle">Opções Avançadas</v-card-title>
                  <v-card-text>
                    <v-row>
                      <v-col>
                        <!-- MENU INICIO VISISVEL -->
                        <v-text-field
                          v-model="collaborativeWork.initVisibilityDate"
                          v-mask="mask"
                          label="Data Inicial para Disponibilizar"
                          prepend-icon="mdi-calendar"
                        ></v-text-field>

                        <!-- MENU INICIO RESPOSTAS -->
                        <v-text-field
                          v-model="collaborativeWork.initAnswerDate"
                          v-mask="mask"
                          label="Data Inicial para Responder"
                          prepend-icon="mdi-calendar"
                        ></v-text-field>
                      </v-col>
                      <v-col>
                        <!-- MENU FINAL VISIVEL -->
                        <v-text-field
                          v-model="collaborativeWork.endVisibilityDate"
                          v-mask="mask"
                          label="Data Final para Disponibilizar"
                          prepend-icon="mdi-calendar"
                        ></v-text-field>
                        <!-- MENU FINAL RESPOSTAS -->
                        <v-text-field
                          v-model="collaborativeWork.endAnswerDate"
                          v-mask="mask"
                          label="Data Final para Responder"
                          prepend-icon="mdi-calendar"
                        ></v-text-field>
                      </v-col>
                    </v-row>
                  </v-card-text>
                </v-card>
              </v-row>
            </v-container>
          </v-card-text>
          <v-card-actions class="mt-n3 pb-6 pr-6">
            <v-spacer></v-spacer>
            <v-btn text color="primary" @click="close">Cancelar</v-btn>
            <v-btn
              v-if="!edit"
              :disabled="!collaborativeWork.description || !collaborativeWork.name"
              color="primary"
              elevation="0"
              @click="addCollaborativeWork"
              >Adicionar</v-btn
            >
            <v-btn
              v-if="edit"
              :disabled="!collaborativeWork.description || !collaborativeWork.name"
              color="primary"
              elevation="0"
              @click="editCollaborativeWork"
              >Editar</v-btn
            >
          </v-card-actions>
        </v-card>
      </v-dialog>
    </v-row>
  </div>
</template>

<script>
import { mask } from 'vue-the-mask'
export default {
  name: 'AddCollaborativeWork',
  directives: {
    mask,
  },
  props: {
    dialog: {
      type: Boolean,
      default: false,
    },
    titleDialog: {
      type: String,
      default: '',
    },
    itemToEdit: {
      type: Object,
      default: () => {},
    },
    edit: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      collaborativeWork: {
        name: '',
        /* maxPerTeam: '', */
        description: '',
        initAnswerDate: '',
        endAnswerDate: '',
        initVisibilityDate: '',
        endVisibilityDate: '',
        file: null,
      },
      disableAdvanced: false,
      mask: '##:## - ##/##/####',
    }
  },
  watch: {
    itemToEdit() {
      this.collaborativeWork = JSON.parse(JSON.stringify(this.itemToEdit))
    },
  },
  methods: {
    addAdvanced() {
      this.disableAdvanced = !this.disableAdvanced
    },
    open() {
      this.$emit('openDialogAddPanel')
    },
    close() {
      this.$emit('closeDialogAddPanel')
      this.disableAdvanced = false
    },
    addCollaborativeWork() {
      this.collaborativeWork = { ...this.collaborativeWork }
      this.$emit('addCollaborativeWork', this.collaborativeWork)
      this.collaborativeWork = {
        name: '',
        maxPerTeam: '',
        description: '',
        initAnswerDate: '',
        endAnswerDate: '',
        initVisibilityDate: '',
        endVisibilityDate: '',
        file: null,
      }
    },
    editCollaborativeWork() {
      this.$emit('editCollaborativeWork', this.collaborativeWork)
    },
  },
}
</script>
